unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Winsock, StrUtils, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Shape1: TShape;
    Image2: TImage;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ok:boolean;

function CurrentUserName:String;
function GetStartDir:String;
procedure WriteLog;
implementation

{$R *.dfm}
function getstartdir:string;
var i,p:word;
begin
  p := 0;
  for i := 1 to length(paramstr(0)) do
  begin
     IF paramstr(0)[i] = '\' THEN p := i;
  end;
  getstartdir :=   COPY(paramstr(0),0,p );
end;


function CurrentUserName:String;
var
  u: array[0..127] of Char;
  sz:Dword;
begin
  sz:=SizeOf(u);
  GetUserName(u,sz);
  Result:=u;
end;

function CurrentHostName:String;
var
  u: array[0..127] of Char;
  sz:Dword;
begin
  sz:=SizeOf(u);
  GetHostName(u,sz);
  Result:=u;
end;


procedure GetHostInfo(var Name, Address: string);
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
begin
  { no error checking...}
  WSAStartup(2, WSAData);
  SetLength(Name, 255);
  Gethostname(PChar(Name), 255);
  SetLength(Name, StrLen(PChar(Name)));
  HostEnt := gethostbyname(PChar(Name));
  with HostEnt^  do
    Address := Format('%d.%d.%d.%d',[
      Byte(h_addr^[0]),
      Byte(h_addr^[1]),
      Byte(h_addr^[2]),
      Byte(h_addr^[3])]);
  WSACleanup;
end;

procedure WriteLog;
var filename:string;
    f:textfile;
    dates,host,address:string;

begin

     {$i-}
     Repeat
     dates := AnsiReplaceStr(datetostr(date), '/', '-');
     filename := getstartdir+'\login\'+dates+'-login.log';
     host := CurrentHostname;
     GetHostInfo(host,address);
     AssignFile(f,filename);
     IF FileExists(filename) then Append(f) else ReWrite(f);
     Writeln(f,datetostr(date)+','+timetostr(time)+','+currentusername+','+host+','+address);
     CloseFile(F);
     Until IOResult = 0;
     {$i+}

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   WriteLog;
   ok := true;
   Form1.Close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     if not ok then canclose := false; 
end;

end.
