unit ela;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, solutil, strutils;

type
  Telamainfrm = class(TForm)
    bg: TImage;
    adate: TDateTimePicker;
    Label1: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  Tloginlog = record
    username: string[40];
    date: TDate;
    time: Ttime;
    computer: string[20];
    ipaddress: string[20];
  end;

var
  elamainfrm: Telamainfrm;
  loginlog: array of Tloginlog;

implementation

{$R *.dfm}

procedure Telamainfrm.Button1Click(Sender: TObject);
var
  f: textfile;
  tempdate, filename: string;
  dummy, a, b, c, d, e: string;
  i: integer;
begin
  tempdate := AnsiReplaceStr(datetostr(date), '/', '-');
  filename := startdir + '\login\' + tempdate + '-login.log';

  i := low(loginlog);

  if fileexists(filename) then
  begin

    memo1.Clear;

    while not eof(f) do
    begin

      assignfile(f, filename);
      Reset(f);
      readln(f, dummy);
      SeparateData(dummy, ',', a, b, c, d, e);
      loginlog[i].date := strtodate(a);
      loginlog[i].time := strtotime(b);
      loginlog[i].username := c;
      loginlog[i].computer := d;
      loginlog[i].ipaddress := e;

      SetlENGTH(loginlog, high(loginlog) + 1);
      inc(i);

    end;

  end
  else
    ShowMessage('No Login Log for this day');

end;

end.

